
module.exports = function(babel, opts = {}) {
  const { useReact = true, ...envOpts } = opts;

  return {
    presets: [
      [ require('@babel/preset-env'), {
        browserslist: '> 0.1%, not dead',
        ...envOpts,
      }],
      [require('@babel/preset-typescript'), {
        isTSX: !!useReact,
        allExtensions: !!useReact,
        allowNamespaces: true,
      }],
      useReact && require('@babel/preset-react'),
    ].filter(n => n),
    plugins: [
      //decorators
      [require('@babel/plugin-proposal-decorators'), {legacy: true}],
      [require('@babel/plugin-proposal-class-properties'), {loose: true}],
      // Private Class Fields
      [require('@babel/plugin-proposal-private-methods'), { loose: true }],

      //object-assign
      require('@babel/plugin-transform-object-assign'),

      //stage0
      require('@babel/plugin-proposal-function-bind'),

      // Stage 1
      require('@babel/plugin-proposal-export-default-from'),
      require('@babel/plugin-proposal-logical-assignment-operators'),
      [require('@babel/plugin-proposal-optional-chaining'), { "loose": false }],
      [require('@babel/plugin-proposal-pipeline-operator'), { "proposal": "minimal" }],
      [require('@babel/plugin-proposal-nullish-coalescing-operator'), { "loose": false }],
      require('@babel/plugin-proposal-do-expressions'),

      // Stage 2
      require('@babel/plugin-proposal-function-sent'),
      require('@babel/plugin-proposal-export-namespace-from'),
      require('@babel/plugin-proposal-numeric-separator'),
      require('@babel/plugin-proposal-throw-expressions'),

      // Stage 3
      require('@babel/plugin-syntax-dynamic-import'),
      require('@babel/plugin-syntax-import-meta'),

      require('@babel/plugin-transform-runtime')
    ]
  };

}
